//
//  ActividadesViewController.swift
//  PowerFitnessApp
//
//  Created by user on 25/7/22.
//

import UIKit

class ActividadesViewController: UIViewController, UICollectionViewDataSource, UICollectionViewDelegate {
    
    var dias: UICollectionView?
    
    var currentSelected: Int?
    
    lazy var lunesVC = LunesViewController()
    lazy var martesVC = MartesViewController()
    lazy var miercolesVC = MiercolesViewController()
    lazy var juevesVC = JuevesViewController()
    lazy var viernesVC = ViernesViewController()
    
    override func viewDidLoad() {
        super.viewDidLoad()
        view.backgroundColor = .systemBackground
        
        title = "Actividades"
        
        let layout: UICollectionViewFlowLayout = UICollectionViewFlowLayout()
        layout.sectionInset = UIEdgeInsets(top: 0, left: 0, bottom: 0, right: 0)
        layout.itemSize = CGSize(width: (self.view.frame.size.width/5)-10, height: 30)
        
        dias = UICollectionView(frame: CGRect(x: 0,
                                              y: 64,
                                              width: self.view.frame.size.width,
                                              height: 30),
                                collectionViewLayout: layout)
        dias?.register(UICollectionViewCell.self, forCellWithReuseIdentifier: "dia")
        dias?.dataSource = self
        dias?.delegate = self
        view.addSubview(dias ?? UICollectionView())
        
        let label = UILabel(frame: CGRect(x: (view.frame.size.width/2)-150,
                                          y: (view.frame.size.height/2)-100,
                                          width: 300,
                                          height: 200))
        label.textAlignment = .center
        label.font = .systemFont(ofSize: 20)
        label.numberOfLines = 2
        label.text = "Selecciona un día\npara ver las actividades"
        label.textColor = .systemGray3
        self.view.addSubview(label)
    }
    
    func collectionView(_ collectionView: UICollectionView, numberOfItemsInSection section: Int) -> Int {
        return 5
    }
    
    func collectionView(_ collectionView: UICollectionView, cellForItemAt indexPath: IndexPath) -> UICollectionViewCell {
        let myCell = collectionView.dequeueReusableCell(withReuseIdentifier: "dia", for: indexPath)
        let title = UILabel(frame: CGRect(x: 0, y: 0, width: myCell.bounds.size.width, height: myCell.bounds.size.height))
        title.font = .systemFont(ofSize: 16)
        title.textAlignment = .center
        myCell.contentView.addSubview(title)
        if indexPath.row == 0 {
            title.text = "LUN"
        } else if indexPath.row == 1 {
            title.text = "MAR"
        } else if indexPath.row == 2 {
            title.text = "MIE"
        } else if indexPath.row == 3 {
            title.text = "JUE"
        } else if indexPath.row == 4 {
            title.text = "VIE"
        }
        return myCell
    }
    
    func collectionView(_ collectionView: UICollectionView, didSelectItemAt indexPath: IndexPath) {
        switch indexPath.row {
        case 0:
            print("...   LUN user tapped on item \(indexPath.row)   ...")
            
            // if user no tiene dietas o rutinas, no se le da acceso
            
            let vc = lunesVC
            self.view.addSubview(vc.view)
            vc.view.frame = CGRect(x: 0,
                                   y: 64 + 30 ,
                                   width: self.view.frame.size.width,
                                   height: self.view.frame.size.height-(64+30))
            
            // else
            
        case 1:
            print("...   MAR user tapped on item \(indexPath.row)   ...")
            
            // if user no tiene dietas o rutinas, no se le da acceso
            
            let vc = martesVC
            self.view.addSubview(vc.view)
            vc.view.frame = CGRect(x: 0,
                                   y: 64 + 30 ,
                                   width: self.view.frame.size.width,
                                   height: self.view.frame.size.height-(64+30))
            
            // else
            
        case 2:
            print("...   MIE user tapped on item \(indexPath.row)   ...")
            
            // if user no tiene dietas o rutinas, no se le da acceso
            
            let vc = miercolesVC
            self.view.addSubview(vc.view)
            vc.view.frame = CGRect(x: 0,
                                   y: 64 + 30 ,
                                   width: self.view.frame.size.width,
                                   height: self.view.frame.size.height-(64+30))
            
            // else
            
        case 3:
            print("...   JUE user tapped on item \(indexPath.row)   ...")
            
            // if user no tiene dietas o rutinas, no se le da acceso
            
            let vc = juevesVC
            self.view.addSubview(vc.view)
            vc.view.frame = CGRect(x: 0,
                                   y: 64 + 30 ,
                                   width: self.view.frame.size.width,
                                   height: self.view.frame.size.height-(64+30))
            
            // else
            
        case 4:
            print("...   VIE user tapped on item \(indexPath.row)   ...")
            
            // if user no tiene dietas o rutinas, no se le da acceso
            
            let vc = viernesVC
            self.view.addSubview(vc.view)
            vc.view.frame = CGRect(x: 0,
                                   y: 64 + 30 ,
                                   width: self.view.frame.size.width,
                                   height: self.view.frame.size.height-(64+30))
            
            // else
            
        default:
            break
        }
    }
    
}


