//
//  LectorPdfViewController.swift
//  PowerFitnessApp
//
//  Created by user on 3/7/22.
//

import UIKit
import PDFKit

class LectorPdfViewController: UIViewController, PDFViewDelegate {

    private let navBar = UINavigationBar()
    
    private let pdf = PDFView()
    
    // cuandop se inicie le debemos de pasar directamente el documento pdf
    let nameDoc: String
    let doc: PDFDocument
    init(doc: PDFDocument, nameDoc: String) {
        self.doc = doc
        self.nameDoc = nameDoc
        super.init(nibName: nil, bundle: nil)
    }
    required init?(coder: NSCoder) {
        fatalError()
    }
    
    override func viewDidLoad() {
        super.viewDidLoad()
        view.backgroundColor = .systemBackground
        
        view.addSubview(navBar)
        
        // añadir pdf
        view.addSubview(pdf)
        
        pdf.document = self.doc
        pdf.delegate = self
        //pdf.autoScales = true
        
        let item = UINavigationItem(title: self.nameDoc)
        navBar.setItems([item], animated: false)
        navBar.barTintColor = .systemBackground
    }
    
    override func viewDidLayoutSubviews() {
        navBar.frame = CGRect(x: 0,
                              y: 0,
                              width: view.frame.size.width,
                              height: 50) // buscar el alto de la barra por defecto, no 50 directamente
        pdf.frame = CGRect(x: 0,
                           y: navBar.frame.height,
                           width: view.frame.size.width,
                           height: view.frame.size.height - navBar.frame.height)
    }

}


