//
//  NovedadesViewController.swift
//  PowerFitnessApp
//
//  Created by user on 3/7/22.
//

import UIKit

class NovedadesViewController: UIViewController, UITableViewDelegate, UITableViewDataSource {
    
    private var tableView =  UITableView()
    
    override func viewDidLoad() {
        super.viewDidLoad()
        view.backgroundColor = .systemBackground
        title = "Novedades"
        
        tableView = UITableView(frame: self.view.bounds)
        tableView.separatorColor = .systemBackground // blanco
        tableView.frame = CGRect(x: 0, y: 0, width: view.frame.size.width, height: view.frame.height)
        //tableView.register(UITableViewCell.self,
        //                   forCellReuseIdentifier: "cell")
        
        // registra la celda de las novedades
        tableView.register(NovedadesTableViewCell.self,
                           forCellReuseIdentifier: NovedadesTableViewCell.identifier)
        view.addSubview(tableView)
        tableView.delegate = self
        tableView.dataSource = self
        
        fetchNovedades()
    }
    
    private var novedades: [Novedad] = []
    
    private func fetchNovedades() {
        print("...   obteniendo novedades   ...")
        DatabaseManager.shared.getNovedades() { [weak self] novedades in
            self?.novedades = novedades
            print("...   se han encontado \(novedades.count) novedades   ...")
            DispatchQueue.main.async {
                self?.tableView.reloadData()
            }
        }
    }
    
    func tableView(_ tableView: UITableView, numberOfRowsInSection section: Int) -> Int {
        return novedades.count
    }
    
    func tableView(_ tableView: UITableView, cellForRowAt indexPath: IndexPath) -> UITableViewCell {
        let novedad = novedades[indexPath.row]
        guard let cell = tableView.dequeueReusableCell(withIdentifier: NovedadesTableViewCell.identifier, for: indexPath) as? NovedadesTableViewCell else {
            fatalError()
        }
        cell.configure(with: .init(titulo: novedad.titulo, imagen: novedad.imagenUrl, cuerpo: novedad.cuerpo))
        return cell
    }
    
    func tableView(_ tableView: UITableView, heightForRowAt indexPath: IndexPath) -> CGFloat {
        return view.frame.size.width+265
    }
    
}


