//
//  JuevesViewController.swift
//  PowerFitnessApp
//
//  Created by user on 25/7/22.
//

import UIKit

enum actividadesJueves {
    case actividad1(viewModels: PreviewActividadTableViewCellViewModel)
    case actividad2(viewModels: PreviewActividadTableViewCellViewModel)
    case actividad3(viewModels: PreviewActividadTableViewCellViewModel)
    case actividad4(viewModels: PreviewActividadTableViewCellViewModel)
    case actividad5(viewModels: PreviewActividadTableViewCellViewModel)
    case actividad6(viewModels: PreviewActividadTableViewCellViewModel)
    case actividad7(viewModels: PreviewActividadTableViewCellViewModel)
}

class JuevesViewController: UIViewController, UITableViewDelegate, UITableViewDataSource {
    
    var tableView = UITableView()
    
    private var actividades = [actividadesJueves]()
    
    override func viewDidLoad() {
        super.viewDidLoad()
        view.backgroundColor = .systemBackground
        
        configureActividades()
        
        tableView.sectionHeaderTopPadding = 0.0
        tableView.frame = CGRect(x: 0, y: 0, width: view.frame.size.width, height: view.frame.size.height-(64+30))
        tableView.register(UITableViewCell.self, forCellReuseIdentifier: "cell")
        tableView.register(PreviewActividadTableViewCell.self,
                           forCellReuseIdentifier: PreviewActividadTableViewCell.identifier)
        view.addSubview(tableView)
        tableView.delegate = self
        tableView.dataSource = self
    }
    
    private func configureActividades() {
        actividades.append(.actividad2(viewModels:
                                        PreviewActividadTableViewCellViewModel(
                                            titulo: "DEFENSA PERSONAL",
                                            imagen: UIImage(named: "defensa_personal"),
                                            hora: "10:00 - 11:00",
                                            descripcion: "Actividad basada en una combinación de técnicas de artes marciales para autodefensa.\n\nActividad destinada para todos los públicos y adaptada a todos los niveles."
                                        )
                                      ))
        actividades.append(.actividad1(viewModels:
                                        PreviewActividadTableViewCellViewModel(
                                            titulo: "HIIT",
                                            imagen: UIImage(named: "hiit"),
                                            hora: "11:00 - 12:00",
                                            descripcion: "Actividad diseñada sobre un entrenamiento de alta intensidad a intervalos para mejorar la capacidad cardiorespiratoria y muscular utilizando todo tipo de material.\n\nAltividad de alto gasto calórico."
                                        )
                                      ))
        actividades.append(.actividad3(viewModels:
                                        PreviewActividadTableViewCellViewModel(
                                            titulo: "COMBAT",
                                            imagen: UIImage(named: "combat"),
                                            hora: "12:00 - 13:00",
                                            descripcion: "Actividad cardiovascular donde se aplican movimientos de diferentes técnicas de combate. Una potente combinación de trabajo aeróbico, coreografías y movimientos a base de puños y patadas."
                                        )
                                      ))
        actividades.append(.actividad5(viewModels:
                                        PreviewActividadTableViewCellViewModel(
                                            titulo: "CARDIO DANCE",
                                            imagen: UIImage(named: "cardio_dance"),
                                            hora: "13:00 - 14:00",
                                            descripcion: "Actividad coreografiada que combina diferentes estilos de baile y ritmos musicales, mejorando la condición cardiovascular. Si te gusta bailar y hacer ejercicio a la vez esta es tu actividad."
                                        )
                                      ))
        actividades.append(.actividad4(viewModels:
                                        PreviewActividadTableViewCellViewModel(
                                            titulo: "CORE",
                                            imagen: UIImage(named: "core"),
                                            hora: "17:00 - 18:00",
                                            descripcion: "Trabajo de la faja natural del cuerpo que comprende abdominal, oblicuos y lumbares (núcleo del cuerpo)."
                                        )
                                      ))
        actividades.append(.actividad7(viewModels:
                                        PreviewActividadTableViewCellViewModel(
                                            titulo: "BOXEO",
                                            imagen: UIImage(named: "boxeo"),
                                            hora: "18:00 - 19:00",
                                            descripcion: "Una emocionante actividad en la que quemarás calorías, definirás tus músculos, aumentarás tu resistencia y coordinación a través de movimientos y la técnica de boxeo."
                                        )
                                      ))
        actividades.append(.actividad6(viewModels:
                                        PreviewActividadTableViewCellViewModel(
                                            titulo: "CROSSFIT",
                                            imagen: UIImage(named: "crossfit"),
                                            hora: "19:00 - 21:00",
                                            descripcion: "CrossFit conecta movimientos de diferentes disciplinas, tales como la halterofilia, el entrenamiento metabólico o el gimnástico.\n\nConsiste en acometer un programa de ejercicios (flexiones, tracción, etc), en un tiempo determinado y con un número definido de veces."
                                        )
                                      ))
    }
    
    
    func numberOfSections(in tableView: UITableView) -> Int {
        return actividades.count
    }
    
    func tableView(_ tableView: UITableView, numberOfRowsInSection section: Int) -> Int {
        return 1
    }
    
    func tableView(_ tableView: UITableView, heightForRowAt indexPath: IndexPath) -> CGFloat {
        return 70
    }
    
    func tableView(_ tableView: UITableView, cellForRowAt indexPath: IndexPath) -> UITableViewCell {
        let actividadType = actividades[indexPath.section]
        switch actividadType {
        case .actividad1(let viewModels):
            guard let cell = tableView.dequeueReusableCell(
                withIdentifier: PreviewActividadTableViewCell.identifier,
                for: indexPath
            ) as? PreviewActividadTableViewCell else {
                fatalError()
            }
            cell.configure(with: viewModels)
            cell.accessoryType = .disclosureIndicator
            return cell
            
        case .actividad2(let viewModels):
            guard let cell = tableView.dequeueReusableCell(
                withIdentifier: PreviewActividadTableViewCell.identifier,
                for: indexPath
            ) as? PreviewActividadTableViewCell else {
                fatalError()
            }
            cell.configure(with: viewModels)
            cell.accessoryType = .disclosureIndicator
            return cell
        case .actividad3(let viewModels):
            guard let cell = tableView.dequeueReusableCell(
                withIdentifier: PreviewActividadTableViewCell.identifier,
                for: indexPath
            ) as? PreviewActividadTableViewCell else {
                fatalError()
            }
            cell.configure(with: viewModels)
            cell.accessoryType = .disclosureIndicator
            return cell
        case .actividad4(let viewModels):
            guard let cell = tableView.dequeueReusableCell(
                withIdentifier: PreviewActividadTableViewCell.identifier,
                for: indexPath
            ) as? PreviewActividadTableViewCell else {
                fatalError()
            }
            cell.configure(with: viewModels)
            cell.accessoryType = .disclosureIndicator
            return cell
        case .actividad5(let viewModels):
            guard let cell = tableView.dequeueReusableCell(
                withIdentifier: PreviewActividadTableViewCell.identifier,
                for: indexPath
            ) as? PreviewActividadTableViewCell else {
                fatalError()
            }
            cell.configure(with: viewModels)
            cell.accessoryType = .disclosureIndicator
            return cell
        case .actividad6(let viewModels):
            guard let cell = tableView.dequeueReusableCell(
                withIdentifier: PreviewActividadTableViewCell.identifier,
                for: indexPath
            ) as? PreviewActividadTableViewCell else {
                fatalError()
            }
            cell.configure(with: viewModels)
            cell.accessoryType = .disclosureIndicator
            return cell
        case .actividad7(let viewModels):
            guard let cell = tableView.dequeueReusableCell(
                withIdentifier: PreviewActividadTableViewCell.identifier,
                for: indexPath
            ) as? PreviewActividadTableViewCell else {
                fatalError()
            }
            cell.configure(with: viewModels)
            cell.accessoryType = .disclosureIndicator
            return cell
        }
    }
    
    func tableView(_ tableView: UITableView, didSelectRowAt indexPath: IndexPath) {
        let actividadType = actividades[indexPath.section]
        switch actividadType {
        case .actividad1(let viewModels):
            let lectorActividadView = LectorActividadViewController(dia: "Jueves",
                                                                    titulo: viewModels.titulo,
                                                                    imagen: viewModels.imagen!,
                                                                    hora: viewModels.hora,
                                                                    descripcion: viewModels.descripcion)
            self.present(lectorActividadView, animated: true, completion: nil)
            
        case .actividad2(let viewModels):
            let lectorActividadView = LectorActividadViewController(dia: "Jueves",
                                                                    titulo: viewModels.titulo,
                                                                    imagen: viewModels.imagen!,
                                                                    hora: viewModels.hora,
                                                                    descripcion: viewModels.descripcion)
            self.present(lectorActividadView, animated: true, completion: nil)
            
        case .actividad3(let viewModels):
            let lectorActividadView = LectorActividadViewController(dia: "Jueves",
                                                                    titulo: viewModels.titulo,
                                                                    imagen: viewModels.imagen!,
                                                                    hora: viewModels.hora,
                                                                    descripcion: viewModels.descripcion)
            self.present(lectorActividadView, animated: true, completion: nil)
            
        case .actividad4(let viewModels):
            let lectorActividadView = LectorActividadViewController(dia: "Jueves",
                                                                    titulo: viewModels.titulo,
                                                                    imagen: viewModels.imagen!,
                                                                    hora: viewModels.hora,
                                                                    descripcion: viewModels.descripcion)
            self.present(lectorActividadView, animated: true, completion: nil)
            
        case .actividad5(let viewModels):
            let lectorActividadView = LectorActividadViewController(dia: "Jueves",
                                                                    titulo: viewModels.titulo,
                                                                    imagen: viewModels.imagen!,
                                                                    hora: viewModels.hora,
                                                                    descripcion: viewModels.descripcion)
            self.present(lectorActividadView, animated: true, completion: nil)
            
        case .actividad6(let viewModels):
            let lectorActividadView = LectorActividadViewController(dia: "Jueves",
                                                                    titulo: viewModels.titulo,
                                                                    imagen: viewModels.imagen!,
                                                                    hora: viewModels.hora,
                                                                    descripcion: viewModels.descripcion)
            self.present(lectorActividadView, animated: true, completion: nil)
            
        case .actividad7(let viewModels):
            let lectorActividadView = LectorActividadViewController(dia: "Jueves",
                                                                    titulo: viewModels.titulo,
                                                                    imagen: viewModels.imagen!,
                                                                    hora: viewModels.hora,
                                                                    descripcion: viewModels.descripcion)
            self.present(lectorActividadView, animated: true, completion: nil)
            
        }
    }
    
}


