//
//  ViernesViewController.swift
//  PowerFitnessApp
//
//  Created by user on 25/7/22.
//

import UIKit

enum actividadesViernes {
    case actividad1(viewModels: PreviewActividadTableViewCellViewModel)
    case actividad2(viewModels: PreviewActividadTableViewCellViewModel)
    case actividad3(viewModels: PreviewActividadTableViewCellViewModel)
    case actividad4(viewModels: PreviewActividadTableViewCellViewModel)
    case actividad5(viewModels: PreviewActividadTableViewCellViewModel)
    case actividad6(viewModels: PreviewActividadTableViewCellViewModel)
}

class ViernesViewController: UIViewController, UITableViewDelegate, UITableViewDataSource {
    
    var tableView = UITableView()
    
    private var actividades = [actividadesViernes]()
    
    override func viewDidLoad() {
        super.viewDidLoad()
        view.backgroundColor = .systemBackground
        
        configureActividades()
        
        tableView.sectionHeaderTopPadding = 0.0
        tableView.frame = CGRect(x: 0, y: 0, width: view.frame.size.width, height: view.frame.size.height-(64+30))
        tableView.register(UITableViewCell.self, forCellReuseIdentifier: "cell")
        tableView.register(PreviewActividadTableViewCell.self,
                           forCellReuseIdentifier: PreviewActividadTableViewCell.identifier)
        view.addSubview(tableView)
        tableView.delegate = self
        tableView.dataSource = self
    }
    
    private func configureActividades() {
        actividades.append(.actividad2(viewModels:
                                        PreviewActividadTableViewCellViewModel(
                                            titulo: "SPINNING",
                                            imagen: UIImage(named: "spinning"),
                                            hora: "10:00 - 11:00",
                                            descripcion: "Es una actividad fundamentalmente aeróbica sobre una bicicleta con especificidad técnica, donde el trabajo cardiovascular, orientado tanto a quemar grasa como a optimizar la capacidad y potencia aeróbica, se realiza en función de ritmos musicales motivantes."
                                        )
                                      ))
        actividades.append(.actividad3(viewModels:
                                        PreviewActividadTableViewCellViewModel(
                                            titulo: "TRX",
                                            imagen: UIImage(named: "trx"),
                                            hora: "11:00 - 12:00",
                                            descripcion: "Entrenamiento en suspensión que se desarrolla por medio de un arnés ajustable no elástico y sujeto a un punto de anclaje.\n\nGran variedad de rutinas y ejercicios para poder desarrullar toda la musculatura."
                                        )
                                      ))
        actividades.append(.actividad1(viewModels:
                                        PreviewActividadTableViewCellViewModel(
                                            titulo: "CROSSFIT",
                                            imagen: UIImage(named: "crossfit"),
                                            hora: "12:00 - 14:00",
                                            descripcion: "CrossFit conecta movimientos de diferentes disciplinas, tales como la halterofilia, el entrenamiento metabólico o el gimnástico.\n\nConsiste en acometer un programa de ejercicios (flexiones, tracción, etc), en un tiempo determinado y con un número definido de veces."
                                        )
                                      ))
        actividades.append(.actividad5(viewModels:
                                        PreviewActividadTableViewCellViewModel(
                                            titulo: "CROSSFIT",
                                            imagen: UIImage(named: "crossfit"),
                                            hora: "17:00 - 19:00",
                                            descripcion: "CrossFit conecta movimientos de diferentes disciplinas, tales como la halterofilia, el entrenamiento metabólico o el gimnástico.\n\nConsiste en acometer un programa de ejercicios (flexiones, tracción, etc), en un tiempo determinado y con un número definido de veces."
                                        )
                                      ))
        actividades.append(.actividad4(viewModels:
                                        PreviewActividadTableViewCellViewModel(
                                            titulo: "GAP",
                                            imagen: UIImage(named: "gap"),
                                            hora: "19:00 - 20:00",
                                            descripcion: "GAP es una clase muy sencilla de seguir, con mucha variedad de ejercicios para hecerla más divertida.\n\nSi queremos poner duros los abdominales, nuestros glúteos y nuestras piernas, los ejercicios específicos y localizados de GAP son lo que necesitamos."
                                        )
                                      ))
        actividades.append(.actividad6(viewModels:
                                        PreviewActividadTableViewCellViewModel(
                                            titulo: "PILATES",
                                            imagen: UIImage(named: "pilates"),
                                            hora: "20:00 - 21:00",
                                            descripcion: "Actividad de control postural con la que fortaleceras la musculatura y trabajarás la tonificación abdominal.\n\nSu pbjetivo no es la quema de calorias, sino reforzar la musculatura y aumentar el control, fuerza y flexibilidad de nuestro cuerpo."
                                        )
                                      ))
    }
    
    
    func numberOfSections(in tableView: UITableView) -> Int {
        return actividades.count
    }
    
    func tableView(_ tableView: UITableView, numberOfRowsInSection section: Int) -> Int {
        return 1
    }
    
    func tableView(_ tableView: UITableView, heightForRowAt indexPath: IndexPath) -> CGFloat {
        return 70
    }
    
    func tableView(_ tableView: UITableView, cellForRowAt indexPath: IndexPath) -> UITableViewCell {
        let actividadType = actividades[indexPath.section]
        switch actividadType {
        case .actividad1(let viewModels):
            guard let cell = tableView.dequeueReusableCell(
                withIdentifier: PreviewActividadTableViewCell.identifier,
                for: indexPath
            ) as? PreviewActividadTableViewCell else {
                fatalError()
            }
            cell.configure(with: viewModels)
            cell.accessoryType = .disclosureIndicator
            return cell
            
        case .actividad2(let viewModels):
            guard let cell = tableView.dequeueReusableCell(
                withIdentifier: PreviewActividadTableViewCell.identifier,
                for: indexPath
            ) as? PreviewActividadTableViewCell else {
                fatalError()
            }
            cell.configure(with: viewModels)
            cell.accessoryType = .disclosureIndicator
            return cell
        case .actividad3(let viewModels):
            guard let cell = tableView.dequeueReusableCell(
                withIdentifier: PreviewActividadTableViewCell.identifier,
                for: indexPath
            ) as? PreviewActividadTableViewCell else {
                fatalError()
            }
            cell.configure(with: viewModels)
            cell.accessoryType = .disclosureIndicator
            return cell
        case .actividad4(let viewModels):
            guard let cell = tableView.dequeueReusableCell(
                withIdentifier: PreviewActividadTableViewCell.identifier,
                for: indexPath
            ) as? PreviewActividadTableViewCell else {
                fatalError()
            }
            cell.configure(with: viewModels)
            cell.accessoryType = .disclosureIndicator
            return cell
        case .actividad5(let viewModels):
            guard let cell = tableView.dequeueReusableCell(
                withIdentifier: PreviewActividadTableViewCell.identifier,
                for: indexPath
            ) as? PreviewActividadTableViewCell else {
                fatalError()
            }
            cell.configure(with: viewModels)
            cell.accessoryType = .disclosureIndicator
            return cell
        case .actividad6(let viewModels):
            guard let cell = tableView.dequeueReusableCell(
                withIdentifier: PreviewActividadTableViewCell.identifier,
                for: indexPath
            ) as? PreviewActividadTableViewCell else {
                fatalError()
            }
            cell.configure(with: viewModels)
            cell.accessoryType = .disclosureIndicator
            return cell
        }
    }
    
    func tableView(_ tableView: UITableView, didSelectRowAt indexPath: IndexPath) {
        let actividadType = actividades[indexPath.section]
        switch actividadType {
        case .actividad1(let viewModels):
            let lectorActividadView = LectorActividadViewController(dia: "Viernes",
                                                                    titulo: viewModels.titulo,
                                                                    imagen: viewModels.imagen!,
                                                                    hora: viewModels.hora,
                                                                    descripcion: viewModels.descripcion)
            self.present(lectorActividadView, animated: true, completion: nil)
            
        case .actividad2(let viewModels):
            let lectorActividadView = LectorActividadViewController(dia: "Viernes",
                                                                    titulo: viewModels.titulo,
                                                                    imagen: viewModels.imagen!,
                                                                    hora: viewModels.hora,
                                                                    descripcion: viewModels.descripcion)
            self.present(lectorActividadView, animated: true, completion: nil)
            
        case .actividad3(let viewModels):
            let lectorActividadView = LectorActividadViewController(dia: "Viernes",
                                                                    titulo: viewModels.titulo,
                                                                    imagen: viewModels.imagen!,
                                                                    hora: viewModels.hora,
                                                                    descripcion: viewModels.descripcion)
            self.present(lectorActividadView, animated: true, completion: nil)
            
        case .actividad4(let viewModels):
            let lectorActividadView = LectorActividadViewController(dia: "Viernes",
                                                                    titulo: viewModels.titulo,
                                                                    imagen: viewModels.imagen!,
                                                                    hora: viewModels.hora,
                                                                    descripcion: viewModels.descripcion)
            self.present(lectorActividadView, animated: true, completion: nil)
            
        case .actividad5(let viewModels):
            let lectorActividadView = LectorActividadViewController(dia: "Viernes",
                                                                    titulo: viewModels.titulo,
                                                                    imagen: viewModels.imagen!,
                                                                    hora: viewModels.hora,
                                                                    descripcion: viewModels.descripcion)
            self.present(lectorActividadView, animated: true, completion: nil)
            
        case .actividad6(let viewModels):
            let lectorActividadView = LectorActividadViewController(dia: "Viernes",
                                                                    titulo: viewModels.titulo,
                                                                    imagen: viewModels.imagen!,
                                                                    hora: viewModels.hora,
                                                                    descripcion: viewModels.descripcion)
            self.present(lectorActividadView, animated: true, completion: nil)
            
        }
    }
    
}


